Data binding in JavaScript Diagram control

Its Essential® for binding external data to the diagram, enabling dynamic creation of nodes and connectors based on the provided data. Here’s a detailed explanation of the key properties and their usage:

DataSource settings

The dataSourceSettings property of diagram configures the external data source that binds to the diagram, making it possible to populate the diagram with nodes and connectors dynamically.

  • Data Manager - Defines the data source as a collection of objects or an instance of DataManager to populate the diagram.

  • ID - The unique identifier for each data in the data source.

  • parentId - Establishes the hierarchical relationship between nodes by linking each node to its parent node. This property is vital for creating tree structures within the diagram.

  • root - Specifies the root node of the diagram when data is loaded. This root node serves as the starting point for the diagram’s structure.

  • The doBinding function is used to customize a node based on the data source. It is triggered during the initialization of each node, allowing you to apply specific configurations or data-driven customizations to the node.

  • Diagram supports two types of data binding. They are:

    1. Local data
    2. Remote data

Local data

Diagram can be populated based on user-defined JSON data (Local Data) by mapping the relevant data source fields.

To map user-defined JSON data to the diagram, configure the fields in dataSourceSettings. The following code example illustrates how to bind local data with the diagram.

var species = [
    { Name: 'Species', fillColor: '#3DD94A' },
    { Name: 'Plants', Category: 'Species' },
    { Name: 'Fungi', Category: 'Species' },
    { Name: 'Lichens', Category: 'Species' },
    { Name: 'Animals', Category: 'Species' },
    { Name: 'Mosses', Category: 'Plants' },
    { Name: 'Ferns', Category: 'Plants' },
    { Name: 'Gymnosperms', Category: 'Plants' },
    { Name: 'Dicotyledens', Category: 'Plants' },
    { Name: 'Monocotyledens', Category: 'Plants' },
    { Name: 'Invertebrates', Category: 'Animals' },
    { Name: 'Vertebrates', Category: 'Animals' },
    { Name: 'Insects', Category: 'Invertebrates' },
    { Name: 'Molluscs', Category: 'Invertebrates' },
    { Name: 'Crustaceans', Category: 'Invertebrates' },
    { Name: 'Others', Category: 'Invertebrates' },
    { Name: 'Fish', Category: 'Vertebrates' },
    { Name: 'Amphibians', Category: 'Vertebrates' },
    { Name: 'Reptiles', Category: 'Vertebrates' },
    { Name: 'Birds', Category: 'Vertebrates' },
    { Name: 'Mammals', Category: 'Vertebrates' },
  ];
  
  ej.diagrams.Diagram.Inject(
    ej.diagrams.DataBinding,
    ej.diagrams.HierarchicalTree
  );
  //Initializes diagram control
  var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: 490,
    //Configures data source
    dataSourceSettings: {
      id: 'Name',
      parentId: 'Category',
      dataManager: new ej.data.DataManager(species),
      //binds the external data with node
      doBinding: function (nodeModel, data, diagram) {
        nodeModel.annotations = [
          {
            content: data.Name,
            margin: { top: 10, left: 10, right: 10, bottom: 10 },
            style: { color: 'black' },
          },
        ];
        nodeModel.style = {
          fill: '#ffeec7',
          strokeColor: '#f5d897',
          strokeWidth: 1,
        };
      },
    },
    //Configrues HierarchicalTree layout
    layout: {
      type: 'HierarchicalTree',
      horizontalSpacing: 15,
      verticalSpacing: 50,
      margin: { top: 10, left: 10, right: 10, bottom: 10 },
    },
    //Sets the default values of nodes
    getNodeDefaults: function (obj, diagram) {
      obj.shape = { type: 'Basic', shape: 'Rectangle' };
      obj.style = { strokeWidth: 1 };
      obj.width = 95;
      obj.height = 30;
    },
    //Sets the default values of connectors.
    getConnectorDefaults: function (connector, diagram) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#4d4d4d';
      connector.targetDecorator.shape = 'None';
    },
    //Disables all interactions except zoom/pan
    tool: ej.diagrams.DiagramTools.ZoomPan,
    snapSettings: { constraints: 0 },
  });
  diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

NOTE

To convert the data source into nodes and connectors, DataBinding should be injected into the diagram.

Remote data

You can bind the diagram with remote data by using dataManager.

DataManager can be bound to remote data source by assigning service end point URL to the url property. With the provided url, the DataManager handles all communication with the data server with help of queries.

When querying data, the DataManager will convert the query object(Query) into server request after calling executeQuery and waits for the server response(JSON format).

The following code illustrates how to bind remote data to the diagram.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
    //Initializes diagram control
    var diagram = new ej.diagrams.Diagram({
        width: '100%', height: 490,
        //Configrues hierarchical tree layout
        layout: {
            type: 'HierarchicalTree', margin: { left: 0, right: 0, top: 100, bottom: 0 },
            verticalSpacing: 40,
            getLayoutInfo: function (node, options) {
                if (options.level === 3) {
                    node.style.fill = '#3c418d';
                }
                if (options.level === 2) {
                    node.style.fill = '#108d8d';
                    options.type = 'Center';
                    options.orientation = 'Horizontal';
                }
                if (options.level === 1) {
                    node.style.fill = '#822b86';
                }
            }
        },
        //Sets the default values of nodes
        getNodeDefaults: function (obj) {
            obj.width = 80;
            obj.height = 40;
            obj.shape = { type: 'Basic', shape: 'Rectangle' };
            obj.style = { fill: '#048785', strokeColor: 'Transparent' };
        },
        //Sets the default values of connector
        getConnectorDefaults: function (connector) {
            connector.type = 'Orthogonal';
            connector.style.strokeColor = '#048785';
            connector.targetDecorator.shape = 'None';
        },
          //Configures data source
          dataSourceSettings: {
            id: 'Id',
            parentId: 'ParentId',
            dataSource: new ej.data.DataManager({ 
            url: 'https://services.syncfusion.com/js/production/api/RemoteData',
            crossDomain: true,
            }),
            //binds the external data with node
            doBinding: function (nodeModel, data, diagram) {
                nodeModel.annotations = [{
                    content: data.Label,
                    style: { color: 'white' }
                }];
            }
        },
        //Disables all interactions except zoom/pan
        tool: ej.diagrams.DiagramTools.ZoomPan,
        snapSettings: { constraints: 0 }
    });
    diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

CRUD

This feature allows you to read the data source and perform add or edit or delete the data in data source at runtime.

Read DataSource

  • This feature allows you to define the nodes and connectors collection in the data source and connectionDataSource respectively.

  • You can set the data collection in the model’s dataSourceSettings dataSource property. The nodes will be generated based on the data specified in the data source.

  • You can set the connector collection in the model’s dataSourceSettings connectionDataSource property.

  • The dataSourceSettings connectionDataSource dataManager property is used to set the data source for the connection data source items.

  • If you have a data (data will be set in the dataSource property) with parent relationship in the database and also defined the connector in the connectionDataSource simultaneously, then the connectors set in the connectionDataSource will be considered as a priority to render the connector.

  • The dataSourceSettings crudAction’s read property specifies the method, which is used to read the data source and its populate the nodes in the diagram.

  • The connectionDataSource crudAction’s read specifies the method, which is used to read the data source and its populates the connectors in the diagram.

  • The dataSourceSettings’s id and connectionDataSource’s id properties are used to define the unique field of each JSON data.

  • The connectionDataSource’s sourceID and targetID properties are used to set the sourceID and targetID for connection data source item.

  • The connectionDataSource’s sourcePointX, sourcePointY, targetPointX, and targetPointY properties are used to define the sourcePoint and targetPoint values for connector from data source.

  • The dataSourceSettings crudAction’s customFields property is used to maintain the additional information for nodes.

  • Similarly, connectionDataSource’s crudAction’s customFields is used to maintain the additional information for connectors.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.HierarchicalTree);
var dataModify = [
    {
        id: "288192",
        IsAssistant: false,
        ParentId: "288200",
        shapeType: "Electrical Analytical Bus",
        load: "2600000 VA",
        current: "3127 A",
        voltage: "480 V",
        Name: "SWGREM4-B"
    },
    {
        id: "288193",
        IsAssistant: false,
        ParentId: "288192",
        shapeType: "Electrical Analytical Transformer",
        load: "800000 VA",
        current: "962 A",
        voltage: "480 V",
        Name: "ATS-EQ-1"
    },
    {
        id: "288198",
        IsAssistant: false,
        ParentId: "288192",
        shapeType: "Electrical Analytical Transfer Switch",
        load: "800000 VA",
        current: "962 A",
        voltage: "480 V",
        Name: "ATS-EQ-2"
    }
];

function designConnectors() {
    var connectors = [];
    var count = 1;

    dataModify.forEach(function (node) {
        var childNodes = checkIfAnyChildExists(node.id);
        childNodes.forEach(function (child) {
            connectors.push({
                id: `connector-${count}`,
                sourceID: node.id,
                srcPortID: `portOut-${child.id}`,
                targetID: child.id,
                targetPortID: `portIn-${child.id}`
            });
            count++;
        });
    });

    return connectors;
}

function checkIfAnyChildExists(id) {
    var childNotes = [];
    dataModify.forEach(function (data) {
        if (data.ParentId === id) {
            childNotes.push(data);
        }
    });
    return childNotes;
}

var diagram = new ej.diagrams.Diagram({
    width: "100%",
    height: "700px",
    snapSettings: { constraints: ej.diagrams.SnapConstraints.None },
    layout: {
        type: "OrganizationalChart",
        verticalSpacing: 100,
        getLayoutInfo: function (node, options) {
            if (!options.hasSubTree) {
                options.orientation = "Horizontal";
            }
        }
    },
    dataSourceSettings: {
        id: "id",
        parentId: "ParentId",
        dataSource: dataModify,
        crudAction: {
            customFields: ["Id", "Description", "Color"]
        },
        connectionDataSource: {
            id: "id",
            sourceID: "sourceID",
            targetID: "targetID",
            crudAction: {
                customFields: ["srcPortID", "targetPortID"]
            },
            dataManager: designConnectors()
        }
    },
    getNodeDefaults: function (node) {
        node.width = 60;
        node.height = 100;
        node.constraints =
            ej.diagrams.NodeConstraints.Default &
            ~ej.diagrams.NodeConstraints.Rotate &
            ~ej.diagrams.NodeConstraints.Resize;
        node.shape = { type: "Basic", shape: "Rectangle" };
        node.style = { fill: "#6BA5D7", strokeColor: "White" };
        return node;
    },
    getConnectorDefaults: function (connector) {
        connector.style = { strokeColor: "black", strokeWidth: 2 };
        connector.targetDecorator = {
            shape: "None",
            style: { fill: "#6BA5D7", strokeColor: "#6BA5D7" }
        };
        connector.type = "Orthogonal";
        connector.segmentThumbShape = "Circle";
        connector.sourcePortID = connector.srcPortID;
        connector.targetPortID = connector.targetPortID;
        return connector;
    }
});

diagram.appendTo("#diagram");
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div class="control-section diagram-organizationalchart">
        <div class="col-lg-8 control-section">
            <div class="content-wrapper">
                <div id="diagram" style="width: 100%; height: 700px;"></div>
            </div>
        </div>
    </div>
    <script src="index.js" type="text/javascript"></script>
</body></html>

How to perform Editing at runtime

  • The dataSourceSettings crudAction object allows you to define the method, which is used to get the changes done in the data source defined for shapes from the client-side to the server-side.

  • Similarly, the connectionDataSource crudAction object allows you to define the method, which is used to get the changes done in the data source defined for connectors from the client-side to the server-side.

InsertData

  • The dataSourceSettings crudAction’s create property specifies the method, which is used to get the nodes added from the client-side to the server-side.

  • The connectionDataSource crudAction’s create specifies the method, which is used to get the connectors added from the client-side to the server-side.

  • The following code example illustrates how to send the newly added or inserted data from the client to server-side.

//Initialize diagram
var diagram = new ej.diagrams.Diagram({
     dataSourceSettings: {
       crudAction:
        {
            //Url which triggers the server side AddNodes method
            create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddNodes',
        },
     }
     connectionDataSource: {
            crudAction: {
                //Url which triggers the server side AddConnectors method
                create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddConnectors',
            }
     }
},'#diagram');
//Sends the newly added nodes/connectors from client side to the server side through the URL which is specified in server side.
diagram.insertData();

UpdateData

  • The dataSourceSettings crudAction’s update property specifies the method, which is used to get the modified nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s update specifies the method, which is used to get the modified connectors from the client-side to the server-side.

  • The following code example illustrates how to send the updated data from the client to the server side.

//Initialize diagram
var diagram = new ej.diagrams.Diagram({
     dataSourceSettings: {
       crudAction:
        {
           //Url which triggers the server side UpdateNodes method
           update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateNodes',
        },
     }
     connectionDataSource: {
        crudAction: {
           //Url which triggers the server side UpdateConnectors method
           update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateConnectors',
        }
     }
},'#diagram');
//Sends the updated nodes/connectors from client side to the server side through the URL which is specified in server side.
diagram.updateData();

DeleteData

  • The dataSourceSettings crudAction’s destroy property specifies the method, which is used to get the deleted nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s destroy specifies the method, which is used to get the deleted connectors from the client-side to the server-side.

//Initialize diagram
var diagram = new ej.diagrams.Diagram({
     dataSourceSettings: {
       crudAction:
        {
          //Url which triggers the server side DeleteNodes method
          destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteNodes',
        },
     }
     connectionDataSource: {
        crudAction: {
           //Url which triggers the server side DeleteConnectors method
           destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteConnectors',
        }
     }
},'#diagram');
//Sends the deleted nodes/connectors from client side to the server side through the URL which is specified in server side.
diagram.removeData();

See Also

Data binding in Vue Diagram component

  • Vue Diagram can be populated with the nodes and connectors based on the information provided from an external data source.

  • Diagram exposes its specific data-related properties allowing you to specify the data source fields from where the node information has to be retrieved from.

  • The dataManager property is used to define the data source either as a collection of objects or as an instance of DataManager that needs to be populated in the diagram.

  • The ID property is used to define the unique field of each JSON data.

  • The parentId property is used to defines the parent field which builds the relationship between ID and parent field.

  • The root property is used to define the root node for the diagram populated from the data source.

  • To explore those properties, see DataSourceSettings.

  • Diagram supports two types of data binding. They are:

    1. Local data
    2. Remote data

Local data

Diagram can be populated based on the user defined JSON data (Local Data) by mapping the relevant data source fields.

To map the user defined JSON data with diagram, configure the fields of dataSourceSettings. The following code example illustrates how to bind local data with the diagram.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :tool='tool' :getNodeDefaults='getNodeDefaults'
            :snapSettings='snapSettings' :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, Diagram, HierarchicalTree, DataBinding, DiagramTools } from '@syncfusion/ej2-vue-diagrams';
import { DataManager } from "@syncfusion/ej2-data";

let species = [{
    'Name': 'Species',
    'fillColor': '#3DD94A'
},
{
    'Name': 'Plants',
    'Category': 'Species'
},
{
    'Name': 'Fungi',
    'Category': 'Species'
},
{
    'Name': 'Lichens',
    'Category': 'Species'
},
{
    'Name': 'Animals',
    'Category': 'Species'
},
{
    'Name': 'Mosses',
    'Category': 'Plants'
},
{
    'Name': 'Ferns',
    'Category': 'Plants'
},
{
    'Name': 'Gymnosperms',
    'Category': 'Plants'
},
{
    'Name': 'Dicotyledens',
    'Category': 'Plants'
},
{
    'Name': 'Monocotyledens',
    'Category': 'Plants'
},
{
    'Name': 'Invertebrates',
    'Category': 'Animals'
},
{
    'Name': 'Vertebrates',
    'Category': 'Animals'
},
{
    'Name': 'Insects',
    'Category': 'Invertebrates'
},
{
    'Name': 'Molluscs',
    'Category': 'Invertebrates'
},
{
    'Name': 'Crustaceans',
    'Category': 'Invertebrates'
},
{
    'Name': 'Others',
    'Category': 'Invertebrates'
},
{
    'Name': 'Fish',
    'Category': 'Vertebrates'
},
{
    'Name': 'Amphibians',
    'Category': 'Vertebrates'
},
{
    'Name': 'Reptiles',
    'Category': 'Vertebrates'
},
{
    'Name': 'Birds',
    'Category': 'Vertebrates'
},
{
    'Name': 'Mammals',
    'Category': 'Vertebrates'
}];

const width = "100%"
const height = "350px"
const getNodeDefaults = (obj) => {
    //Initialize shape
    obj.shape = {
        type: 'Basic',
        shape: 'Rectangle'
    };
    obj.style = {
        strokeWidth: 1
    };
    obj.width = 95;
    obj.height = 30;
}
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    connector.style.strokeColor = '#4d4d4d';
    connector.targetDecorator.shape = 'None';
}
const snapSettings = {
    constraints: 0
}
const tool = DiagramTools.ZoomPan;
const layout = {
    type: 'HierarchicalTree',
    horizontalSpacing: 15,
    verticalSpacing: 50,
    margin: {
        top: 10,
        left: 10,
        right: 10,
        bottom: 0
    }
}
const dataSourceSettings = {
    id: 'Name',
    parentId: 'Category',
    dataManager: new DataManager(species),
    //binds the external data with node
    doBinding: (nodeModel, data, diagram) => {
        nodeModel.annotations = [{
            /* tslint:disable:no-string-literal */
            content: data['Name'],
            margin: {
                top: 10,
                left: 10,
                right: 10,
                bottom: 0
            },
            style: {
                color: 'black'
            }
        }];
        /* tslint:disable:no-string-literal */
        nodeModel.style = {
            fill: '#ffeec7',
            strokeColor: '#f5d897',
            strokeWidth: 1
        };
    }
}

provide('diagram', [DataBinding, HierarchicalTree]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :tool='tool' :getNodeDefaults='getNodeDefaults'
            :snapSettings='snapSettings' :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, Diagram, HierarchicalTree, DataBinding, DiagramTools } from '@syncfusion/ej2-vue-diagrams';
import { DataManager } from "@syncfusion/ej2-data";

let species = [{
    'Name': 'Species',
    'fillColor': '#3DD94A'
},
{
    'Name': 'Plants',
    'Category': 'Species'
},
{
    'Name': 'Fungi',
    'Category': 'Species'
},
{
    'Name': 'Lichens',
    'Category': 'Species'
},
{
    'Name': 'Animals',
    'Category': 'Species'
},
{
    'Name': 'Mosses',
    'Category': 'Plants'
},
{
    'Name': 'Ferns',
    'Category': 'Plants'
},
{
    'Name': 'Gymnosperms',
    'Category': 'Plants'
},
{
    'Name': 'Dicotyledens',
    'Category': 'Plants'
},
{
    'Name': 'Monocotyledens',
    'Category': 'Plants'
},
{
    'Name': 'Invertebrates',
    'Category': 'Animals'
},
{
    'Name': 'Vertebrates',
    'Category': 'Animals'
},
{
    'Name': 'Insects',
    'Category': 'Invertebrates'
},
{
    'Name': 'Molluscs',
    'Category': 'Invertebrates'
},
{
    'Name': 'Crustaceans',
    'Category': 'Invertebrates'
},
{
    'Name': 'Others',
    'Category': 'Invertebrates'
},
{
    'Name': 'Fish',
    'Category': 'Vertebrates'
},
{
    'Name': 'Amphibians',
    'Category': 'Vertebrates'
},
{
    'Name': 'Reptiles',
    'Category': 'Vertebrates'
},
{
    'Name': 'Birds',
    'Category': 'Vertebrates'
},
{
    'Name': 'Mammals',
    'Category': 'Vertebrates'
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "350px",
            getNodeDefaults: (obj) => {
                //Initialize shape
                obj.shape = {
                    type: 'Basic',
                    shape: 'Rectangle'
                };
                obj.style = {
                    strokeWidth: 1
                };
                obj.width = 95;
                obj.height = 30;
            },
            getConnectorDefaults: (connector) => {
                connector.type = 'Orthogonal';
                connector.style.strokeColor = '#4d4d4d';
                connector.targetDecorator.shape = 'None';
            },
            snapSettings: {
                constraints: 0
            },
            tool: DiagramTools.ZoomPan,
            layout: {
                type: 'HierarchicalTree',
                horizontalSpacing: 15,
                verticalSpacing: 50,
                margin: {
                    top: 10,
                    left: 10,
                    right: 10,
                    bottom: 0
                },
            },
            dataSourceSettings: {
                id: 'Name',
                parentId: 'Category',
                dataManager: new DataManager(species),
                //binds the external data with node
                doBinding: (nodeModel, data, diagram) => {
                    nodeModel.annotations = [{
                        /* tslint:disable:no-string-literal */
                        content: data['Name'],
                        margin: {
                            top: 10,
                            left: 10,
                            right: 10,
                            bottom: 0
                        },
                        style: {
                            color: 'black'
                        }
                    }];
                    /* tslint:disable:no-string-literal */
                    nodeModel.style = {
                        fill: '#ffeec7',
                        strokeColor: '#f5d897',
                        strokeWidth: 1
                    };
                }
            },
        }
    },
    provide: {
        diagram: [DataBinding, HierarchicalTree]
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Remote data

You can bind the diagram with remote data by using [dataManager].

It uses two different classes: DataManager for processing and Query for serving data. DataManager communicates with data source and Query generates data queries that are read by the dataManager.

To learn more about data manager, refer to Data Manager.

To bind remote data to the diagram,configure the fields of dataSourceSettings. The following code illustrates how to bind remote data to the diagram.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :tool='tool' :getNodeDefaults='getNodeDefaults'
            :snapSettings='snapSettings' :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, DataBinding, HierarchicalTree, DiagramTools } from '@syncfusion/ej2-vue-diagrams';
import { DataManager } from "@syncfusion/ej2-data";

const width = "100%";
const height = "350px";
const layout = {
    type: 'HierarchicalTree', margin: { left: 0, right: 0, top: 100, bottom: 0 },
    verticalSpacing: 40,
    getLayoutInfo: (node, options) => {
        if (options.level === 3) {
            node.style.fill = '#3c418d';
        }
        if (options.level === 2) {
            node.style.fill = '#108d8d';
            options.type = 'Center';
            options.orientation = 'Horizontal';
        }
        if (options.level === 1) {
            node.style.fill = '#822b86';
        }
    }
}
//Sets the default values of nodes
const getNodeDefaults = (obj) => {
    obj.width = 80;
    obj.height = 40;
    //Initialize shape
    obj.shape = { type: 'Basic', shape: 'Rectangle' };
    obj.style = { fill: '#048785', strokeColor: 'Transparent' };
}
//Sets the default values of connector
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    connector.style.strokeColor = '#048785';
    connector.targetDecorator.shape = 'None';
}
const dataSourceSettings = {
    id: "Id",
    parentId: "ParentId",
    dataSource: new DataManager(
        {
            url: "https://services.syncfusion.com/vue/production/api/RemoteData",
            crossDomain: true
        },
    ),
    //binds the external data with node
    doBinding: (nodeModel, data, diagram) => {
        nodeModel.annotations = [
            {
                /* tslint:disable:no-string-literal */
                content: data["Label"],
                style: { color: "white" }
            }
        ];
    }
}
//Disables all interactions except zoom/pan
const tool = DiagramTools.ZoomPan
const snapSettings = { constraints: 0 }

provide('diagram', [DataBinding, HierarchicalTree]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :tool='tool' :getNodeDefaults='getNodeDefaults'
            :snapSettings='snapSettings' :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, DataBinding, HierarchicalTree, DiagramTools } from '@syncfusion/ej2-vue-diagrams';
import { DataManager } from "@syncfusion/ej2-data";

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "350px",
            layout: {
                type: 'HierarchicalTree', margin: { left: 0, right: 0, top: 100, bottom: 0 },
                verticalSpacing: 40,
                getLayoutInfo: (node, options) => {
                    if (options.level === 3) {
                        node.style.fill = '#3c418d';
                    }
                    if (options.level === 2) {
                        node.style.fill = '#108d8d';
                        options.type = 'Center';
                        options.orientation = 'Horizontal';
                    }
                    if (options.level === 1) {
                        node.style.fill = '#822b86';
                    }
                }
            },
            //Sets the default values of nodes
            getNodeDefaults: (obj) => {
                obj.width = 80;
                obj.height = 40;
                //Initialize shape
                obj.shape = { type: 'Basic', shape: 'Rectangle' };
                obj.style = { fill: '#048785', strokeColor: 'Transparent' };
            },
            //Sets the default values of connector
            getConnectorDefaults: (connector) => {
                connector.type = 'Orthogonal';
                connector.style.strokeColor = '#048785';
                connector.targetDecorator.shape = 'None';
            },
            dataSourceSettings: {
                id: "Id",
                parentId: "ParentId",
                dataSource: new DataManager(
                    {
                        url: "https://services.syncfusion.com/vue/production/api/RemoteData",
                        crossDomain: true
                    },
                ),
                //binds the external data with node
                doBinding: (nodeModel, data, diagram) => {
                    nodeModel.annotations = [
                        {
                            /* tslint:disable:no-string-literal */
                            content: data["Label"],
                            style: { color: "white" }
                        }
                    ];
                }
            },
            //Disables all interactions except zoom/pan
            tool: DiagramTools.ZoomPan,
            snapSettings: { constraints: 0 }
        }
    },
    provide: {
        diagram: [DataBinding, HierarchicalTree]
    },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

CRUD

This feature allows you to read the data source and perform add or edit or delete the data in data source at runtime.

Read DataSource

  • This feature allows you to define the nodes and connectors collection in the data source and connectionDataSource respectively.

  • You can set the data collection in the model’s dataSourceSettings dataSource property. The nodes will be generated based on the data specified in the data source.

  • You can set the connector collection in the model’s dataSourceSettings connectionDataSource property.

  • The dataSourceSettings connectionDataSource dataManager property is used to set the data source for the connection data source items.

  • If you have a data (data will be set in the dataSource property) with parent relationship in the database and also defined the connector in the connectionDataSource simultaneously, then the connectors set in the connectionDataSource will be considered as a priority to render the connector.

  • The dataSourceSettings crudAction’s read property specifies the method, which is used to read the data source and its populate the nodes in the diagram.

  • The connectionDataSource crudAction’s read specifies the method, which is used to read the data source and its populates the connectors in the diagram.

  • The dataSourceSettings’s id and connectionDataSource’s id properties are used to define the unique field of each JSON data.

  • The connectionDataSource’s sourceID and targetID properties are used to set the sourceID and targetID for connection data source item.

  • The connectionDataSource’s sourcePointX, sourcePointY, targetPointX, and targetPointY properties are used to define the sourcePoint and targetPoint values for connector from data source.

  • The dataSourceSettings crudAction’s customFields property is used to maintain the additional information for nodes.

  • Similarly, connectionDataSource’s crudAction’s customFields is used to maintain the additional information for connectors.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
            :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, DataBinding, HierarchicalTree, DiagramTools } from '@syncfusion/ej2-vue-diagrams';
import { DataManager } from "@syncfusion/ej2-data";
const data = [
    { id: "288192",  Name: "SWGREM4-B", shapeType: "Electrical Analytical Bus" },
      { id: "288193", ParentId: "288192", Name: "ATS-EQ-1", shapeType: "Electrical Analytical Transformer" },
      { id: "288198", ParentId: "288192", Name: "ATS-EQ-2", shapeType: "Electrical Analytical Transfer Switch" }
];

const designConnectors = () => {
        let connectors = [];
        let count = 1;
        data.forEach(node => {
            const childNodes = checkIfAnyChildExists(node.id);
            childNodes.forEach((child, index) => {
                connectors.push(
                    {
                        "id": `connector-${count}`,
                        "sourceID": node.id,
                        "srcPortID": `portOut-${child.id}`,
                        "targetID": child.id,
                        "targetPortID": `portIn-${child.id}`,
                    }
                );
                count = count + 1;
            });
        });
        return connectors;
}

const checkIfAnyChildExists = (id) => {
    let childNotes = [];
        data.forEach((data) => {
          if (data.ParentId == id) {
            childNotes.push(data);
          }
        });
        return childNotes;
}
const width = "100%";
const height = "350px";
const layout = {
    type: 'OrganizationalChart',
}
//Sets the default values of nodes
const getNodeDefaults = (node) => {
    node.width = 75; node.height = 40;
}
//Sets the default values of connector
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
}
const dataSourceSettings = {
    id: 'id',
    dataSource: data,
    connectionDataSource: { 
        id: 'id',  
        sourceID: 'sourceID',
        targetID: 'targetID',
        dataManager: designConnectors()
    }
}
//Disables all interactions except zoom/pan
const tool = DiagramTools.ZoomPan
const snapSettings = { constraints: 0 }

provide('diagram', [DataBinding, HierarchicalTree]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
            :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, HierarchicalTree, DataBinding } from '@syncfusion/ej2-vue-diagrams';
import { DataManager, Query } from "@syncfusion/ej2-data";

let data = [
    { id: "288192",  Name: "SWGREM4-B", shapeType: "Electrical Analytical Bus" },
      { id: "288193", ParentId: "288192", Name: "ATS-EQ-1", shapeType: "Electrical Analytical Transformer" },
      { id: "288198", ParentId: "288192", Name: "ATS-EQ-2", shapeType: "Electrical Analytical Transfer Switch" }
];



const designConnectors = () => {
        let connectors = [];
        let count = 1;
        data.forEach(node => {
            const childNodes = checkIfAnyChildExists(node.id);
            childNodes.forEach((child, index) => {
                connectors.push(
                    {
                        "id": `connector-${count}`,
                        "sourceID": node.id,
                        "srcPortID": `portOut-${child.id}`,
                        "targetID": child.id,
                        "targetPortID": `portIn-${child.id}`,
                    }
                );
                count = count + 1;
            });
        });
        return connectors;
}

const checkIfAnyChildExists = (id) => {
    let childNotes = [];
        data.forEach((data) => {
          if (data.ParentId == id) {
            childNotes.push(data);
          }
        });
        return childNotes;
}

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "590px",
            //Uses layout to auto-arrange nodes on the Diagram page
            layout: {
                //Sets layout type
                type: 'OrganizationalChart',
            },
            //Configures data source for Diagram
            dataSourceSettings: {
                id: 'id',
                //parentId: 'ParentId',
                dataSource: data,
                connectionDataSource: { 
                    id: 'id',  
                    sourceID: 'sourceID',
                    targetID: 'targetID',
                    dataManager: designConnectors()
                }
            },
            //Sets the default properties for nodes and connectors
            getNodeDefaults: (node) => {
                //node.annotations = [{ content: node.data.Role }];
                node.width = 75; node.height = 40;
                return node;
            },
            getConnectorDefaults: (connector) => {
                connector.type = 'Orthogonal';
                return connector;
            },
        }
    },
    provide: {
        diagram: [HierarchicalTree, DataBinding]
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

How to perform Editing at runtime

  • The dataSourceSettings crudAction object allows you to define the method, which is used to get the changes done in the data source defined for shapes from the client-side to the server-side.

  • Similarly, the connectionDataSource crudAction object allows you to define the method, which is used to get the changes done in the data source defined for connectors from the client-side to the server-side.

InsertData

  • The dataSourceSettings crudAction’s create property specifies the method, which is used to get the nodes added from the client-side to the server-side.

  • The connectionDataSource crudAction’s create specifies the method, which is used to get the connectors added from the client-side to the server-side.

  • The following code example illustrates how to send the newly added or inserted data from the client to server-side.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
            dataSourceSettings: {
            crudAction: {
              //Url which triggers the server side AddNodes method
              create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddNodes',
           },
           connectionDataSource: {
             crudAction: {
                //Url which triggers the server side AddConnectors method
                create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddConnectors',
             }
           }
         }
        }
    }
    mounted: function() {
        let diagramInstance: Diagram;
        let diagramObj: any = document.getElementById("diagram");
        diagramInstance = diagramObj.ej2_instances[0];
        //Sends the inserted nodes/connectors from client side to the server side through the URL which is specified in server side.
        diagramInstance.insertData();
    }
}

UpdateData

  • The dataSourceSettings crudAction’s update property specifies the method, which is used to get the modified nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s update specifies the method, which is used to get the modified connectors from the client-side to the server-side.

  • The following code example illustrates how to send the updated data from the client to the server side.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
            dataSourceSettings: {
            crudAction: {
              //Url which triggers the server side UpdateNodes method
              update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateNodes',
            },
           connectionDataSource: {
             crudAction: {
             //Url which triggers the server side UpdateConnectors method
              update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateConnectors',
            }
           }
         }
        }
    }
    mounted: function() {
        let diagramInstance: Diagram;
        let diagramObj: any = document.getElementById("diagram");
        diagramInstance = diagramObj.ej2_instances[0];
        //Sends the updated nodes/connectors from client side to the server side through the URL which is specified in server side.
        diagramInstance.updateData();
    }
}

DeleteData

  • The dataSourceSettings crudAction’s destroy property specifies the method, which is used to get the deleted nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s destroy specifies the method, which is used to get the deleted connectors from the client-side to the server-side.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
            dataSourceSettings: {
            crudAction: {
               //Url which triggers the server side DeleteNodes method
                destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteNodes',
           },
           connectionDataSource: {
               crudAction: {
                //Url which triggers the server side DeleteConnectors method
                destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteConnectors',
                }
               }
            }
        }
    }
    mounted: function() {
        let diagramInstance: Diagram;
        let diagramObj: any = document.getElementById("diagram");
        diagramInstance = diagramObj.ej2_instances[0];
        //Sends the deleted nodes/connectors from client side to the server side through the URL which is specified in server side.
        diagramInstance.removeData();
    }
}

See Also

Data Binding in Angular Diagram Component

The Angular Diagram component supports data binding to populate nodes and connectors from external data sources. This feature enables dynamic diagram creation based on structured data, making it ideal for visualizing organizational charts, flowcharts, and hierarchical data structures.

Data binding in the Diagram component works by mapping data source fields to diagram elements through the dataSourceSettings property. The component supports both local JSON data and remote data sources, providing flexibility for various application scenarios.

Key Data Binding Properties

The Diagram component exposes several data-related properties that control how data is mapped to diagram elements:

  • dataManager - Defines the data source as a collection of objects or DataManager instance
  • ID - Specifies the unique identifier field for each data item
  • parentId - Defines the parent field to establish hierarchical relationships
  • root - Sets the root node for the diagram hierarchy

For complete property details, refer to the DataSourceSettings API documentation.

Data Binding Types

The Diagram component supports two primary data binding approaches:

  1. Local data binding - Uses client-side JSON data
  2. Remote data binding - Fetches data from server endpoints using DataManager

Local Data Binding

Local data binding allows the diagram to render nodes and connectors based on client-side JSON data. This approach is ideal for static data or scenarios where the entire dataset is available on the client side.

To implement local data binding, configure the dataSourceSettings fields to map your JSON data structure to diagram elements.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DiagramModule, HierarchicalTreeService, DataBindingService } from '@syncfusion/ej2-angular-diagrams'



import { Component, ViewEncapsulation } from '@angular/core';
import { Diagram, NodeModel, ConnectorModel, SnapConstraints, SnapSettingsModel, DiagramTools } from '@syncfusion/ej2-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
import { DecoratorModel, StrokeStyleModel } from '@syncfusion/ej2-angular-diagrams';
let species: object[] = [
    { 'Name': 'Species', 'fillColor': '#3DD94A' },
    { 'Name': 'Plants', 'Category': 'Species' },
    { 'Name': 'Fungi', 'Category': 'Species' },
    { 'Name': 'Lichens', 'Category': 'Species' },
    { 'Name': 'Animals', 'Category': 'Species' },
    { 'Name': 'Mosses', 'Category': 'Plants' },
    { 'Name': 'Ferns', 'Category': 'Plants' },
    { 'Name': 'Gymnosperms', 'Category': 'Plants' },
    { 'Name': 'Dicotyledens', 'Category': 'Plants' },
    { 'Name': 'Monocotyledens', 'Category': 'Plants' },
    { 'Name': 'Invertebrates', 'Category': 'Animals' },
    { 'Name': 'Vertebrates', 'Category': 'Animals' },
    { 'Name': 'Insects', 'Category': 'Invertebrates' },
    { 'Name': 'Molluscs', 'Category': 'Invertebrates' },
    { 'Name': 'Crustaceans', 'Category': 'Invertebrates' },
    { 'Name': 'Others', 'Category': 'Invertebrates' },
    { 'Name': 'Fish', 'Category': 'Vertebrates' },
    { 'Name': 'Amphibians', 'Category': 'Vertebrates' },
    { 'Name': 'Reptiles', 'Category': 'Vertebrates' },
    { 'Name': 'Birds', 'Category': 'Vertebrates' },
    { 'Name': 'Mammals', 'Category': 'Vertebrates' }
];
@Component({
imports: [
         DiagramModule
    ],

providers: [HierarchicalTreeService, DataBindingService],
standalone: true,
  selector: "app-container",
  // specifies the template string for the diagram component
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="490px" [getConnectorDefaults]='connDefaults' [getNodeDefaults]='nodeDefaults' [tool]='tool' [layout]='layout' [dataSourceSettings]='data' [snapSettings]='snapSettings'>
  </ejs-diagram>`
})
export class AppComponent {
    public node?: NodeModel;
    public nodeDefaults(node: NodeModel): NodeModel {
        let obj: NodeModel = {};
        obj.shape = { type: 'Basic', shape: 'Rectangle' };
        obj.style = { strokeWidth: 1 };
        obj.width = 95;
        obj.height = 30;
        return obj;
    };
    public data: Object = {
        id: 'Name', parentId: 'Category', dataManager: new DataManager(species),
        //binds the external data with node
        doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
            nodeModel.annotations = [{
                /* tslint:disable:no-string-literal */
                content: data['Name'], margin: { top: 10, left: 10, right: 10, bottom: 0 },
                style: { color: 'black' }
            }];
            /* tslint:disable:no-string-literal */
            nodeModel.style = { fill: '#ffeec7', strokeColor: '#f5d897', strokeWidth: 1 };
        }
    };

    public connDefaults(connector: ConnectorModel): void {
        connector.type = 'Orthogonal';
        ((connector as ConnectorModel).style as StrokeStyleModel).strokeColor = '#4d4d4d';
        ((connector as ConnectorModel).targetDecorator as DecoratorModel).shape = 'None';
    };

    public tool: DiagramTools = DiagramTools.ZoomPan;
    public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
    public layout: Object = {
        type: 'HierarchicalTree', horizontalSpacing: 40, verticalSpacing: 40,
        margin: { top: 10, left: 10, right: 10, bottom: 0 }
    };
}
export interface DataInfo {
    [key: string]: string;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Remote Data Binding

Remote data binding enables the diagram to fetch data from server endpoints using the DataManager service. This approach is suitable for large datasets, real-time data, or when data needs to be retrieved from databases or web services.

The DataManager handles data communication, while Query objects generate the requests that DataManager processes. This architecture provides powerful data manipulation capabilities including filtering, sorting, and paging.

For comprehensive DataManager information, see the DataManager documentation.

import { Component, ViewEncapsulation } from '@angular/core';
import { Diagram, NodeModel, DiagramTools, SnapSettingsModel, SnapConstraints } from '@syncfusion/ej2-diagrams';
import { DataManager } from '@syncfusion/ej2-data';
import { DataBindingService, DiagramComponent, DiagramModule, HierarchicalTreeService } from '@syncfusion/ej2-angular-diagrams';

@Component({
    imports: [
        DiagramModule
    ],
    providers: [HierarchicalTreeService, DataBindingService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [snapSettings]='snapSettings' [getConnectorDefaults]='connDefaults' [getNodeDefaults]='nodeDefaults' [tool]='tool' [layout]='layout' [dataSourceSettings]='data1' >
</ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {

    public diagram?: DiagramComponent;

    public nodeDefaults(obj: NodeModel): NodeModel {
        obj.width = 80;
        obj.height = 40;
        obj.shape = { type: 'Basic', shape: 'Rectangle' };
        obj.style = { fill: '#048785', strokeColor: 'Transparent' };
        return obj;
    };

    public data1: Object = {
        id: 'Id', parentId: 'ParentId',
        dataSource: new DataManager(
            { url: 'https://services.syncfusion.com/js/production/api/RemoteData', crossDomain: true },

        ),
        //binds the external data with node
        doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
            nodeModel.annotations = [{
                /* tslint:disable:no-string-literal */
                content: data['Label'],
                style: { color: 'white' }
            }];
        }
    };

    public connDefaults(connector: any): void {
        connector.type = 'Orthogonal';
        connector.style.strokeColor = '#048785';
        connector.targetDecorator.shape = 'None';
    };

    public tool: DiagramTools = DiagramTools.ZoomPan;
    public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };

    public layout: Object = {
        type: 'HierarchicalTree', margin: { left: 0, right: 0, top: 100, bottom: 0 },
        verticalSpacing: 40,
    };
}
export interface DataInfo {
    [key: string]: string;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

CRUD Operations with Data Binding

The Diagram component supports Create, Read, Update, and Delete (CRUD) operations, allowing real-time synchronization between the diagram and its data source. This functionality enables users to modify diagram elements and persist changes to the backend.

Reading Data from Multiple Sources

The diagram can simultaneously read from two data sources: one for nodes and another for connectors. This separation provides greater flexibility when dealing with complex data relationships.

Node data source configuration:

  • Set the dataSource property to define the node data collection
  • Use the id property to specify the unique identifier field

Connector data source configuration:

Priority handling: When both parent-child relationships in the main data source and explicit connectors in the connectionDataSource are defined, the explicit connectors take priority for rendering.

Custom fields: Use the customFields property in crudAction to maintain additional information for both nodes and connectors.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, LayoutAnimation, TreeInfo, SnapSettingsModel, Node, DataBinding, HierarchicalTree, SnapConstraints, DiagramModule, DecoratorModel, ShapeStyleModel, NodeConstraints } from '@syncfusion/ej2-angular-diagrams';

Diagram.Inject(DataBinding, HierarchicalTree, LayoutAnimation);

export interface EmployeeInfo {
    Role: string;
    color: string;
}

export interface DataInfo {
    [key: string]: string;
}

export interface ConnectorInfo {
    id: string;
    sourceID: string;
    srcPortID: string;
    targetID: string;
    targetPortID: string;
}

/** 
 * Sample for Organizational Chart
 */
@Component({
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="700px" [getConnectorDefaults]='getConnectorDefaults' [getNodeDefaults]='getNodeDefaults' [layout]='layout' [dataSourceSettings]='data'  >
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
    standalone: true,
    imports: [DiagramModule,]
})
export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;

    // Define the connectors array with the appropriate type
    public connectors: ConnectorInfo[] = [];

    public dataModify = [
        {
            "id": "288192",
            "IsAssistant": false,
            "ParentId": "288200",
            "shapeType": "Electrical Analytical Bus",
            "load": "2600000 VA",
            "current": "3127 A",
            "voltage": "480 V",
            "Name": "SWGREM4-B"
        },
        {
            "id": "288193",
            "IsAssistant": false,
            "ParentId": "288192",
            "shapeType": "Electrical Analytical Transformer",
            "load": "800000 VA",
            "current": "962 A",
            "voltage": "480 V",
            "Name": "ATS-EQ-1"
        },
        {
            "id": "288198",
            "IsAssistant": false,
            "ParentId": "288192",
            "shapeType": "Electrical Analytical Transfer Switch",
            "load": "800000 VA",
            "current": "962 A",
            "voltage": "480 V",
            "Name": "ATS-EQ-2"
        },
    ];

    public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };

    public data = {
        id: 'id',
        parentId: 'ParentId',
        dataSource: this.dataModify,
        crudAction: {
            customFields: [
                'Id',
                'Description',
                'Color',
            ],
        },
        connectionDataSource: {
            id: 'id',
            sourceID: 'sourceID',
            targetID: 'targetID',
            crudAction: {
                customFields: [
                    'srcPortID', 'targetPortID'
                ],
            },
            dataManager: this.designConnectors()
        }
    };

    public layout: Object = {
        type: 'OrganizationalChart',
        verticalSpacing: 100,
        getLayoutInfo: (node: Node, options: TreeInfo) => {
            if (!options.hasSubTree) {
                options.orientation = 'Horizontal';
            }
        }
    };

    designConnectors() {
        this.connectors = [];
        let count = 1;
        this.dataModify.forEach(node => {
            const childNodes = this.checkIfAnyChildExists(node.id);
            childNodes.forEach((child: { id: string }) => {
                this.connectors.push(
                    {
                        id: `connector-${count}`,
                        sourceID: node.id,
                        srcPortID: `portOut-${child.id}`,
                        targetID: child.id,
                        targetPortID: `portIn-${child.id}`
                    }
                );
                count++;
            });
        });
        return this.connectors;
    }

    checkIfAnyChildExists(id: string) {
        let childNotes: any = [];
        this.dataModify.forEach((data: any) => {
            if (data.ParentId == id) {
                childNotes.push(data);
            }
        });
        return childNotes;
    }

    public getNodeDefaults(node: NodeModel, diagram?: Diagram): any {
        node.width = 60;
        node.height = 100;
        node.constraints =
            NodeConstraints.Default &
            ~NodeConstraints.Rotate &
            ~NodeConstraints.Resize;
        node.shape = { type: 'Basic', shape: 'Rectangle' };
        ((node as NodeModel).style as ShapeStyleModel).fill = "#6BA5D7";
        ((node as NodeModel).style as ShapeStyleModel).strokeColor = "White";
        return node;
    }

    public getConnectorDefaults(connector: any, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: 'black',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill = '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor = '#6BA5D7';
        connector.targetDecorator.shape = 'None';
        connector.type = 'Orthogonal';
        connector.segmentThumbShape = 'Circle';
        connector.sourcePortID = connector.srcPortID;
        connector.targetPortID = connector.targetPortID;
        return connector;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Runtime Data Modification

The diagram supports real-time data modifications through CRUD action configuration. Each operation (create, update, delete) can be mapped to specific server endpoints that handle the corresponding data changes.

Creating New Data (InsertData)

Configure the create property to handle new node and connector additions:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent} from '@syncfusion/ej2-angular-diagrams';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [dataSourceSettings]='data'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram: DiagramComponent;
    public data: Object = {
      crudAction: {
        //Url which triggers the server side AddNodes method
        create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddNodes',
      },
      connectionDataSource: {
      crudAction: {
           //Url which triggers the server side AddConnectors method
           create: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddConnectors',
        }
      }
    };
     //Sends the inserted nodes/connectors from client side to the server side through the URL which is specified in server side.
     this.diagram.insertData();
 }

Updating Existing Data (UpdateData)

Configure the update property to handle modifications to existing nodes and connectors:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent} from '@syncfusion/ej2-angular-diagrams';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [dataSourceSettings]='data'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram: DiagramComponent;
    public data: Object = {
      crudAction: {
         //Url which triggers the server side UpdateNodes method
           update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateNodes',
      },
      connectionDataSource: {
      crudAction: {
           //Url which triggers the server side UpdateConnectors method
           update: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateConnectors',
        }
      }
    };
     //Sends the updated nodes/connectors from client side to the server side through the URL which is specified in server side.
     this.diagram.updateData();
 }

Deleting Data (DeleteData)

Configure the destroy property to handle node and connector deletions:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent} from '@syncfusion/ej2-angular-diagrams';

@Component({
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [dataSourceSettings]='data'>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram: DiagramComponent;
    public data: Object = {
      crudAction: {
         //Url which triggers the server side DeleteNodes method
          destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteNodes',
      },
      connectionDataSource: {
      crudAction: {
           //Url which triggers the server side DeleteConnectors method
           destroy: 'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteConnectors',
        }
      }
    };
     //Sends the deleted nodes/connectors from client side to the server side through the URL which is specified in server side.
     this.diagram.removeData();
 }

See Also

Data Binding in React Diagram Component

The React Diagram component supports data binding to populate nodes and connectors from external data sources. This feature enables dynamic diagram creation based on structured data, making it ideal for visualizing organizational charts, flowcharts, and hierarchical data structures.

Data binding in the Diagram component works by mapping data source fields to diagram elements through the dataSourceSettings property. The component supports both local JSON data and remote data sources, providing flexibility for various application scenarios.

Key Data Binding Properties

The Diagram component exposes several data-related properties that control how data is mapped to diagram elements:

  • The dataManager property is used to define the data source either as a collection of objects or as an instance of DataManager that needs to be populated in the diagram.

  • The ID property is used to define the unique field of each JSON data.

  • The parentId property is used to defines the parent field which builds the relationship between ID and parent field.

  • The root property is used to define the root node for the diagram populated from the data source.

  • To explore those properties, see DataSourceSettings.

Data Binding Types

The Diagram component supports two primary data binding approaches:

  1. Local data binding - Uses client-side JSON data.
  2. Remote data binding - Fetches data from server endpoints using DataManager.

Local Data Binding

Local data binding allows the diagram to render nodes and connectors based on client-side JSON data. This approach is ideal for static data or scenarios where the entire dataset is available on the client side.

To implement local data binding, configure the [dataSourceSettings]fields to map your JSON data structure to diagram elements.

The following code example illustrates how to bind local data with the diagram.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DataBinding, HierarchicalTree, DiagramTools, Inject } from "@syncfusion/ej2-react-diagrams";
import { DataManager } from '@syncfusion/ej2-data';
let species = [
    { 'Name': 'Species', 'fillColor': '#3DD94A' },
    { 'Name': 'Plants', 'Category': 'Species' },
    { 'Name': 'Fungi', 'Category': 'Species' },
    { 'Name': 'Lichens', 'Category': 'Species' },
    { 'Name': 'Animals', 'Category': 'Species' },
    { 'Name': 'Mosses', 'Category': 'Plants' },
    { 'Name': 'Ferns', 'Category': 'Plants' },
    { 'Name': 'Gymnosperms', 'Category': 'Plants' },
    { 'Name': 'Dicotyledens', 'Category': 'Plants' },
    { 'Name': 'Monocotyledens', 'Category': 'Plants' },
    { 'Name': 'Invertebrates', 'Category': 'Animals' },
    { 'Name': 'Vertebrates', 'Category': 'Animals' },
    { 'Name': 'Insects', 'Category': 'Invertebrates' },
    { 'Name': 'Molluscs', 'Category': 'Invertebrates' },
    { 'Name': 'Crustaceans', 'Category': 'Invertebrates' },
    { 'Name': 'Others', 'Category': 'Invertebrates' },
    { 'Name': 'Fish', 'Category': 'Vertebrates' },
    { 'Name': 'Amphibians', 'Category': 'Vertebrates' },
    { 'Name': 'Reptiles', 'Category': 'Vertebrates' },
    { 'Name': 'Birds', 'Category': 'Vertebrates' },
    { 'Name': 'Mammals', 'Category': 'Vertebrates' }
];
const layout = {
    type: 'HierarchicalTree',
    horizontalSpacing: 15,
    verticalSpacing: 50,
    margin: {
        top: 10,
        left: 10,
        right: 10,
        bottom: 0,
    },
};
const dataSourceSettings = {
    id: 'Name',
    parentId: 'Category',
    dataManager: new DataManager(species),
    //binds the external data with node
    doBinding: (nodeModel, data, diagram) => {
        nodeModel.annotations = [
            {
                /* tslint:disable:no-string-literal */
                content: data['Name'],
                margin: {
                    top: 10,
                    left: 10,
                    right: 10,
                    bottom: 0,
                },
                style: {
                    color: 'black',
                },
            },
        ];
        /* tslint:disable:no-string-literal */
        nodeModel.style = {
            fill: '#ffeec7',
            strokeColor: '#f5d897',
            strokeWidth: 1,
        };
    },
};
//Initializes diagram control
function App() {
    return (<DiagramComponent id="container" width={'100%'} height={490} 
    //Configures data source
    dataSourceSettings={dataSourceSettings} 
    //Configrues HierarchicalTree layout
    layout={layout} 
    //Sets the default values of nodes
    getNodeDefaults={(obj, diagram) => {
            //Initialize shape
            obj.shape = {
                type: 'Basic',
                shape: 'Rectangle',
            };
            obj.style = {
                strokeWidth: 1,
            };
            obj.width = 95;
            obj.height = 30;
        }} 
    //Sets the default values of connectors
    getConnectorDefaults={(connector, diagram) => {
            connector.type = 'Orthogonal';
            connector.style.strokeColor = '#4d4d4d';
            connector.targetDecorator.shape = 'None';
        }} 
    //Disables all interactions except zoom/pan
    tool={DiagramTools.ZoomPan} snapSettings=>
      <Inject services={[DataBinding, HierarchicalTree]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    NodeModel,
    ConnectorModel,
    Node,
    DataBinding,
    HierarchicalTree,
    DiagramTools,
    Inject
} from "@syncfusion/ej2-react-diagrams";
import {
    DataManager
} from '@syncfusion/ej2-data';

let species: object[] = [
    { 'Name': 'Species', 'fillColor': '#3DD94A' },
    { 'Name': 'Plants', 'Category': 'Species' },
    { 'Name': 'Fungi', 'Category': 'Species' },
    { 'Name': 'Lichens', 'Category': 'Species' },
    { 'Name': 'Animals', 'Category': 'Species' },
    { 'Name': 'Mosses', 'Category': 'Plants' },
    { 'Name': 'Ferns', 'Category': 'Plants' },
    { 'Name': 'Gymnosperms', 'Category': 'Plants' },
    { 'Name': 'Dicotyledens', 'Category': 'Plants' },
    { 'Name': 'Monocotyledens', 'Category': 'Plants' },
    { 'Name': 'Invertebrates', 'Category': 'Animals' },
    { 'Name': 'Vertebrates', 'Category': 'Animals' },
    { 'Name': 'Insects', 'Category': 'Invertebrates' },
    { 'Name': 'Molluscs', 'Category': 'Invertebrates' },
    { 'Name': 'Crustaceans', 'Category': 'Invertebrates' },
    { 'Name': 'Others', 'Category': 'Invertebrates' },
    { 'Name': 'Fish', 'Category': 'Vertebrates' },
    { 'Name': 'Amphibians', 'Category': 'Vertebrates' },
    { 'Name': 'Reptiles', 'Category': 'Vertebrates' },
    { 'Name': 'Birds', 'Category': 'Vertebrates' },
    { 'Name': 'Mammals', 'Category': 'Vertebrates' }
];
const layout = {
  type: 'HierarchicalTree',
  horizontalSpacing: 15,
  verticalSpacing: 50,
  margin: {
    top: 10,
    left: 10,
    right: 10,
    bottom: 0,
  },
};
const dataSourceSettings = {
  id: 'Name',
  parentId: 'Category',
  dataManager: new DataManager(species),
  //binds the external data with node
  doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
    nodeModel.annotations = [
      {
        /* tslint:disable:no-string-literal */
        content: data['Name'],
        margin: {
          top: 10,
          left: 10,
          right: 10,
          bottom: 0,
        },
        style: {
          color: 'black',
        },
      },
    ];
    /* tslint:disable:no-string-literal */
    nodeModel.style = {
      fill: '#ffeec7',
      strokeColor: '#f5d897',
      strokeWidth: 1,
    };
  },
};
//Initializes diagram control
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={490}
      //Configures data source
      dataSourceSettings={dataSourceSettings}
      //Configrues HierarchicalTree layout
      layout={layout}
      //Sets the default values of nodes
      getNodeDefaults={(obj: Node, diagram: Diagram) => {
        //Initialize shape
        obj.shape = {
          type: 'Basic',
          shape: 'Rectangle',
        };
        obj.style = {
          strokeWidth: 1,
        };
        obj.width = 95;
        obj.height = 30;
      }}
      //Sets the default values of connectors
      getConnectorDefaults={(connector: ConnectorModel, diagram: Diagram) => {
        connector.type = 'Orthogonal';
        connector.style.strokeColor = '#4d4d4d';
        connector.targetDecorator.shape = 'None';
      }}
      //Disables all interactions except zoom/pan
      tool={DiagramTools.ZoomPan}
      snapSettings=
    >
      <Inject services={[DataBinding, HierarchicalTree]} />
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

export interface EmployeeInfo {
    Role: string;
    color: string;
}
export interface DataInfo {
    [key: string]: string;
}

Remote Data Binding

Remote data binding enables the diagram to fetch data from server endpoints using the DataManager service. This approach is suitable for large datasets, real-time data, or when data needs to be retrieved from databases or web services.

The DataManager handles data communication, while Query objects generate the requests that DataManager processes. This architecture provides powerful data manipulation capabilities including filtering, sorting, and paging.

For comprehensive DataManager information, see the dataSourceSettings. The following code illustrates how to bind remote data to the diagram.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DataBinding, HierarchicalTree, DiagramTools, Inject } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from '@syncfusion/ej2-data';

const layout = {
    type: 'HierarchicalTree',
    margin: {
        left: 0,
        right: 0,
        top: 100,
        bottom: 0,
    },
    verticalSpacing: 40,
    getLayoutInfo: (node, options) => {
        if (options.level === 3) {
            node.style.fill = '#3c418d';
        }
        if (options.level === 2) {
            node.style.fill = '#108d8d';
            options.type = 'Center';
            options.orientation = 'Horizontal';
        }
        if (options.level === 1) {
            node.style.fill = '#822b86';
        }
    },
};

const dataSourceSettings = {
    id: "Id",
    parentId: "ParentId",
    dataSource: new DataManager({
        url: "https://services.syncfusion.com/react/production/api/RemoteData",
        crossDomain: true
    }),
    //binds the external data with node
    doBinding: (nodeModel, data, diagram) => {
        nodeModel.annotations = [
            {
                /* tslint:disable:no-string-literal */
                content: data["Label"],
                style: { color: "white" }
            }
        ];
    }
};

//Initializes diagram control
function App() {
    return (<DiagramComponent id="container" width={'100%'} height={490} 
    layout={layout} 
    //Sets the default values of nodes
    getNodeDefaults={(obj) => {
            obj.width = 80;
            obj.height = 40;
            //Initialize shape
            obj.shape = {
                type: 'Basic',
                shape: 'Rectangle',
            };
            obj.style = {
                fill: '#048785',
                strokeColor: 'Transparent',
            };
        }} 
    //Sets the default values of connector
    getConnectorDefaults={(connector) => {
            connector.type = 'Orthogonal';
            connector.style.strokeColor = '#048785';
            connector.targetDecorator.shape = 'None';
        }} 
    //Configures data source
        dataSourceSettings={dataSourceSettings}
    //Disables all interactions except zoom/pan
    tool={DiagramTools.ZoomPan} snapSettings=>
      <Inject services={[DataBinding, HierarchicalTree]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    NodeModel,
    Node,
    Connector,
    DataBinding,
    HierarchicalTree,
    TreeInfo,
    DiagramTools,
    Inject,
    ConnectorModel
} from "@syncfusion/ej2-react-diagrams";
import {
    DataManager,
    Query
} from '@syncfusion/ej2-data';

const layout = {
  type: 'HierarchicalTree',
  margin: {
    left: 0,
    right: 0,
    top: 100,
    bottom: 0,
  },
  verticalSpacing: 40,
  getLayoutInfo: (node: Node, options: TreeInfo) => {
    if (options.level === 3) {
      node.style.fill = '#3c418d';
    }
    if (options.level === 2) {
      node.style.fill = '#108d8d';
      options.type = 'Center';
      options.orientation = 'Horizontal';
    }
    if (options.level === 1) {
      node.style.fill = '#822b86';
    }
  },
};

const dataSourceSettings = {
  id: "Id",
  parentId: "ParentId",
  dataSource: new DataManager({
      url: "https://services.syncfusion.com/react/production/api/RemoteData",
      crossDomain: true
  }),
  //binds the external data with node
  doBinding: (nodeModel: NodeModel, data: DataInfo, diagram: Diagram) => {
      nodeModel.annotations = [
          {
              /* tslint:disable:no-string-literal */
              content: data["Label"],
              style: { color: "white" }
          }
      ];
  }
};

//Initializes diagram control
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={490}
      //Configrues hierarchical tree layout
      layout={layout}
      //Sets the default values of nodes
      getNodeDefaults={(obj: NodeModel) => {
        obj.width = 80;
        obj.height = 40;
        //Initialize shape
        obj.shape = {
          type: 'Basic',
          shape: 'Rectangle',
        };
        obj.style = {
          fill: '#048785',
          strokeColor: 'Transparent',
        };
      }}
      //Sets the default values of connector
      getConnectorDefaults={(connector: ConnectorModel) => {
        connector.type = 'Orthogonal';
        connector.style.strokeColor = '#048785';
        connector.targetDecorator.shape = 'None';
      }}
      //Configures data source
      dataSourceSettings={dataSourceSettings}
      //Disables all interactions except zoom/pan
      tool={DiagramTools.ZoomPan}
      snapSettings=
    >
      <Inject services={[DataBinding, HierarchicalTree]} />
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

export interface DataInfo {
    [key: string]: string;
}

CRUD operations with Data Binding

The Diagram component supports Create, Read, Update, and Delete (CRUD) operations, allowing real-time synchronization between the diagram and its data source. This functionality enables users to modify diagram elements and persist changes to the backend.

Reading Data from Multiple Sources

The diagram can simultaneously read from two data sources: one for nodes and another for connectors. This separation provides greater flexibility when dealing with complex data relationships.

Node Data Source Configuration:

  • Set the dataSource property to define the node data collection

*Use the id property to specify the unique identifier field

Connector Data Source Configuration:

Priority handling: When both parent-child relationships in the main data source and explicit connectors in the connectionDataSource are defined, the explicit connectors take priority for rendering.

  • The dataSourceSettings crudAction’s read property specifies the method, which is used to read the data source and its populate the nodes in the diagram.

  • The connectionDataSource crudAction’s read specifies the method, which is used to read the data source and its populates the connectors in the diagram.

Custom fields: Use the customFields property in crudAction to maintain additional information for both nodes and connectors.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import {
  DiagramComponent,
  Inject,
  DataBinding,
  HierarchicalTree,
} from "@syncfusion/ej2-react-diagrams";

const App = () => {
  const diagramRef = useRef(null);

  const dataModify = [
    {
      id: "288192",
      IsAssistant: false,
      ParentId: "288200",
      shapeType: "Electrical Analytical Bus",
      load: "2600000 VA",
      current: "3127 A",
      voltage: "480 V",
      Name: "SWGREM4-B",
    },
    {
      id: "288193",
      IsAssistant: false,
      ParentId: "288192",
      shapeType: "Electrical Analytical Transformer",
      load: "800000 VA",
      current: "962 A",
      voltage: "480 V",
      Name: "ATS-EQ-1",
    },
    {
      id: "288198",
      IsAssistant: false,
      ParentId: "288192",
      shapeType: "Electrical Analytical Transfer Switch",
      load: "800000 VA",
      current: "962 A",
      voltage: "480 V",
      Name: "ATS-EQ-2",
    },
  ];

  const designConnectors = () => {
    const connectors = [];
    let count = 1;

    dataModify.forEach((node) => {
      const childNodes = checkIfAnyChildExists(node.id);
      childNodes.forEach((child) => {
        connectors.push({
          id: `connector-${count}`,
          sourceID: node.id,
          srcPortID: `portOut-${child.id}`,
          targetID: child.id,
          targetPortID: `portIn-${child.id}`,
        });
        count++;
      });
    });

    return connectors;
  };

  const checkIfAnyChildExists = (id) => {
    return dataModify.filter((data) => data.ParentId === id);
  };

  const getNodeDefaults = (node) => {
    node.width = 60;
    node.height = 100;
    node.shape = { type: "Basic", shape: "Rectangle" };
    node.style = { fill: "#6BA5D7", strokeColor: "White" };
    return node;
  };

  const getConnectorDefaults = (connector) => {
    connector.style = { strokeColor: "black", strokeWidth: 2 };
    connector.targetDecorator = {
      shape: "None",
      style: { fill: "#6BA5D7", strokeColor: "#6BA5D7" },
    };
    connector.type = "Orthogonal";
    connector.segmentThumbShape = "Circle";
    connector.sourcePortID = connector.srcPortID;
    connector.targetPortID = connector.targetPortID;
    return connector;
  };

  const layout = {
    type: "OrganizationalChart",
    verticalSpacing: 100,
    getLayoutInfo: (node, options) => {
      if (!options.hasSubTree) {
        options.orientation = "Horizontal";
      }
    },
  };

  const dataSourceSettings = {
    id: "id",
    parentId: "ParentId",
    dataSource: dataModify,
    crudAction: {
      customFields: ["Id", "Description", "Color"],
    },
    connectionDataSource: {
      id: "id",
      sourceID: "sourceID",
      targetID: "targetID",
      crudAction: {
        customFields: ["srcPortID", "targetPortID"],
      },
      dataManager: designConnectors(),
    },
  };

  return (
    <DiagramComponent
      id="container"
      ref={diagramRef}
      width="100%"
      height="700px"
      layout={layout}
      dataSourceSettings={dataSourceSettings}
      getNodeDefaults={getNodeDefaults}
      getConnectorDefaults={getConnectorDefaults}
    >
      <Inject services={[DataBinding, HierarchicalTree]} />
    </DiagramComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { useRef } from "react";
import {
  DiagramComponent,
  Inject,
  DataBinding,
  HierarchicalTree,
} from "@syncfusion/ej2-react-diagrams";

const App = () => {
  const diagramRef = useRef(null);

  const dataModify = [
    {
      id: "288192",
      IsAssistant: false,
      ParentId: "288200",
      shapeType: "Electrical Analytical Bus",
      load: "2600000 VA",
      current: "3127 A",
      voltage: "480 V",
      Name: "SWGREM4-B",
    },
    {
      id: "288193",
      IsAssistant: false,
      ParentId: "288192",
      shapeType: "Electrical Analytical Transformer",
      load: "800000 VA",
      current: "962 A",
      voltage: "480 V",
      Name: "ATS-EQ-1",
    },
    {
      id: "288198",
      IsAssistant: false,
      ParentId: "288192",
      shapeType: "Electrical Analytical Transfer Switch",
      load: "800000 VA",
      current: "962 A",
      voltage: "480 V",
      Name: "ATS-EQ-2",
    },
  ];

  const designConnectors = () => {
    const connectors = [];
    let count = 1;

    dataModify.forEach((node) => {
      const childNodes = checkIfAnyChildExists(node.id);
      childNodes.forEach((child) => {
        connectors.push({
          id: `connector-${count}`,
          sourceID: node.id,
          srcPortID: `portOut-${child.id}`,
          targetID: child.id,
          targetPortID: `portIn-${child.id}`,
        });
        count++;
      });
    });

    return connectors;
  };

  const checkIfAnyChildExists = (id) => {
    return dataModify.filter((data) => data.ParentId === id);
  };

  const getNodeDefaults = (node) => {
    node.width = 60;
    node.height = 100;
    node.shape = { type: "Basic", shape: "Rectangle" };
    node.style = { fill: "#6BA5D7", strokeColor: "White" };
    return node;
  };

  const getConnectorDefaults = (connector) => {
    connector.style = { strokeColor: "black", strokeWidth: 2 };
    connector.targetDecorator = {
      shape: "None",
      style: { fill: "#6BA5D7", strokeColor: "#6BA5D7" },
    };
    connector.type = "Orthogonal";
    connector.segmentThumbShape = "Circle";
    connector.sourcePortID = connector.srcPortID;
    connector.targetPortID = connector.targetPortID;
    return connector;
  };

  const layout = {
    type: "OrganizationalChart",
    verticalSpacing: 100,
    getLayoutInfo: (node, options) => {
      if (!options.hasSubTree) {
        options.orientation = "Horizontal";
      }
    },
  };

  const dataSourceSettings = {
    id: "id",
    parentId: "ParentId",
    dataSource: dataModify,
    crudAction: {
      customFields: ["Id", "Description", "Color"],
    },
    connectionDataSource: {
      id: "id",
      sourceID: "sourceID",
      targetID: "targetID",
      crudAction: {
        customFields: ["srcPortID", "targetPortID"],
      },
      dataManager: designConnectors(),
    },
  };

  return (
    <DiagramComponent
      id="container"
      ref={diagramRef}
      width="100%"
      height="700px"
      layout={layout}
      dataSourceSettings={dataSourceSettings}
      getNodeDefaults={getNodeDefaults}
      getConnectorDefaults={getConnectorDefaults}
    >
      <Inject services={[DataBinding, HierarchicalTree]} />
    </DiagramComponent>
  );
};

const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

How to Perform Editing at Runtime

  • The dataSourceSettings crudAction object allows you to define the method, which is used to get the changes done in the data source defined for shapes from the client-side to the server-side.

  • Similarly, the connectionDataSource crudAction object allows you to define the method, which is used to get the changes done in the data source defined for connectors from the client-side to the server-side.

Creating New Data (InsertData)

  • The dataSourceSettings crudAction’s create property specifies the method, which is used to get the nodes added from the client-side to the server-side.

  • The connectionDataSource crudAction’s create specifies the method, which is used to get the connectors added from the client-side to the server-side.

  • The following code example illustrates how to send the newly added or inserted data from the client to server-side.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    Inject,
    DataBinding
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
function App() {
  return (
    <DiagramComponent
      id="container"
      // diagram instance for an diagram
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'550px'}
      //Configures data source for diagram
      dataSourceSettings={{
        crudAction: {
          //Url which triggers the server side AddNodes method
          create:
            'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddNodes',
        },
        connectionDataSource: {
          crudAction: {
            //Url which triggers the server side AddConnectors method
            create:
              'https://ej2services.syncfusion.com/development/web-services/api/Crud/AddConnectors',
          },
        },
      }}
    >
      <Inject services={[DataBinding]} />
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

//Sends the inserted nodes/connectors from client side to the server side through the URL which is specified in server side.
diagramInstance.insertData();

UpdateData

  • The dataSourceSettings crudAction’s update property specifies the method, which is used to get the modified nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s update specifies the method, which is used to get the modified connectors from the client-side to the server-side.

  • The following code example illustrates how to send the updated data from the client to the server side.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    Inject,
    DataBinding
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
function App() {
  return (
    <DiagramComponent
      id="container"
      // diagram instance for an diagram
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'550px'}
      //Configures data source for diagram
      dataSourceSettings={{
        crudAction: {
          //Url which triggers the server side UpdateNodes method
          update:
            'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateNodes',
        },
        connectionDataSource: {
          crudAction: {
            //Url which triggers the server side UpdateConnectors method
            update:
              'https://ej2services.syncfusion.com/development/web-services/api/Crud/UpdateConnectors',
          },
        },
      }}
    >
      <Inject services={[DataBinding]} />
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

//Sends the updated nodes/connectors from client side to the server side through the URL which is specified in server side.
diagramInstance.updateData();

DeleteData

  • The dataSourceSettings crudAction’s destroy property specifies the method, which is used to get the deleted nodes from the client-side to the server-side.

  • The connectionDataSource crudAction’s destroy specifies the method, which is used to get the deleted connectors from the client-side to the server-side.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    Diagram,
    DiagramComponent,
    Inject,
    DataBinding
} from "@syncfusion/ej2-react-diagrams";
let diagramInstance: DiagramComponent;
function App() {
  return (
    <DiagramComponent
      id="container"
      // diagram instance for an diagram
      ref={(diagram) => (diagramInstance = diagram)}
      width={'100%'}
      height={'550px'}
      //Configures data source for diagram
      dataSourceSettings={{
        crudAction: {
          //Url which triggers the server side DeleteNodes method
          destroy:
            'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteNodes',
        },
        connectionDataSource: {
          crudAction: {
            //Url which triggers the server side DeleteConnectors method
            destroy:
              'https://ej2services.syncfusion.com/development/web-services/api/Crud/DeleteConnectors',
          },
        },
      }}
    >
      <Inject services={[DataBinding]} />
    </DiagramComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

//Sends the deleted nodes/connectors from client side to the server side through the URL which is specified in server side.
diagramInstance.removeData();

See Also